#ifndef cmplex_included
#define cmplex_included

class cmplex {
 public:
    double x, y;
    cmplex(const double& x);
    cmplex(const double& x, const double& y);
    cmplex(const cmplex& z);
    cmplex();
    ~cmplex() {}
    void print() const;
    void print(ofstream& fout) const;
    void setby(const double& x, const double& y);
    void write(ofstream& fout) const;
    void read( ifstream& fin);
    void operator= (const cmplex& a);
    void operator+=(const cmplex& a);
    void operator-=(const cmplex& a);
    void operator= (const double& a);
    void operator+=(const double& a);
    void operator-=(const double& a);
    cmplex operator-() const;
    cmplex operator+(const cmplex&  a) const;
    cmplex operator+(const double&  a) const;
    cmplex operator-(const cmplex&  a) const;
    cmplex operator-(const double&  a) const;
    cmplex operator*(const cmplex&  a) const;
    cmplex operator*(const double&  a) const;
    cmplex operator/(const cmplex&  a) const;
    cmplex operator/(const double&  a) const;
    bool   operator==(const cmplex& a) const;
    bool   operator!=(const cmplex& a) const;
};

cmplex operator*(const double& val, const cmplex& a);
cmplex operator/(const double& val, const cmplex& a);
cmplex Prod(const cmplex& a, const cmplex& b);
cmplex Conj(const cmplex& a);
double Re(const cmplex& a);
double Im(const cmplex& a);
//extern cmplex ii;

#endif
