#ifndef line_included
#define line_included

#include "line_def.h"

class line {
    vectZ1    Lsize_;
    vectR1    Lmin_;
    vectR1    Lmax_;
    vectR1    dB_;
    QsmpZ     SpZ_;
    QsmpI     SpI_;

public:
    line(){}
    line(const vectZ1& Lsize,
          const vectR1& Lmax,
          const vectR1& Lmin);
    ~line(){}
    void  setby(const vectZ1& Lsize,
                const vectR1& Lmax,
                const vectR1& Lmin);
    const vectZ1& Lsize()    const { return Lsize_; }
    const vectZ1& nBrickes() const { return Lsize_; }
    const vectR1& dBricke()  const { return dB_;    }
    const vectR1& dB()       const { return dB_;    }
    const vectR1& dL()       const { return dB_;    }
    const vectR1& Lmin()     const { return Lmin_;  }
    const vectR1& Lmax()     const { return Lmax_;  }
    QsmpZ& SpZ() { return SpZ_;   }
    QsmpI& SpI() { return SpI_; }
    const QsmpZ& SpZ() const { return SpZ_;   }
    const QsmpI& SpI() const { return SpI_; }

    void print() const;
    void print(ofstream& fout) const;
    void write(ofstream& fout) const;
    void read(ifstream& fin);

    // I -> I (divergence(), convertSV(), inverseMatrixPCGM())
    iSqI Ip(const iSqI& iI) const;
    iSqI Im(const iSqI& iI) const;

    // Zero -> I (convert)
    iSqI Ip(const iSqZ& iZ) const;
    iSqI Im(const iSqZ& iZ) const;

    // I -> Zero (convert)
    iSqZ Zp(const iSqI& iI) const;
    iSqZ Zm(const iSqI& iI) const;

    // Zero -> Zero (convert)
    iSqZ Zp(const iSqZ& iZ) const;
    iSqZ Zm(const iSqZ& iZ) const;

};

#endif
