#ifndef matC2x2_included
#define matC2x2_included

class matC2x2{
 public:
    cmplex a11, a12, a21, a22;
    matC2x2(const matC2x2& m);
    matC2x2(const cmplex& a11, const cmplex& a12,
            const cmplex& a21, const cmplex& a22);
    matC2x2(const double& a11, const double& a12,
            const double& a21, const double& a22);
    matC2x2();
    ~matC2x2() {}
    void print() const;
    void print(ofstream& fout) const;
    void setby(const cmplex& a11, const cmplex& a12,
               const cmplex& a21, const cmplex& a22);
    void setby(const double& a11, const double& a12,
               const double& a21, const double& a22);
    void write(ofstream& fout) const;
    void read( ifstream& fin);
    void operator=(const matC2x2& m);
    void operator+=(const matC2x2& m);
    void operator-=(const matC2x2& m);
    matC2x2 operator-() const;
    matC2x2 operator*(const cmplex& ac) const;
    matC2x2 operator*(const double& ar) const;
    matC2x2 operator/(const cmplex& ac) const;
    matC2x2 operator/(const double& ar) const;
    matC2x2 operator+(const matC2x2& m) const;
    matC2x2 operator-(const matC2x2& m) const;
    matC2x2 operator*(const matC2x2& m) const;
    vectC2  operator*(const vectC2& v) const;
    bool operator==(const matC2x2& m) const;
    bool operator!=(const matC2x2& m) const;
    bool operator<=(const matC2x2& m) const;
    bool operator>=(const matC2x2& m) const;
    bool operator<(const matC2x2& m) const;
    bool operator>(const matC2x2& m) const;
};

matC2x2 operator*(const double& val, const matC2x2& a);
matC2x2 operator*(const cmplex& val, const matC2x2& a);
cmplex  det(const matC2x2& m);
matC2x2 inv(const matC2x2& m);
matC2x2 transp(const matC2x2& m);
matC2x2 Hconj( const matC2x2& m);

#endif
