#ifndef vectII_included
#define vectII_included

template<class T> class vectII{
 public:
    T x, y;
    vectII(const vectII<T>& a);
    vectII(const T& x, const T& y);
    vectII();
    ~vectII() {}
    void print() const;
    void print(ofstream& fout) const;
    void setby(const T& x, const T& y);
    void write(ofstream& fout) const;
    void read( ifstream& fin);
    void operator=(const vectII<T>& a);
    void operator+=(const vectII<T>& a);
    void operator-=(const vectII<T>& a);
    vectII<T> operator-() const;
    vectII<T> operator+(const T& val)       const;
    vectII<T> operator-(const T& val)       const;
    vectII<T> operator*(const T& val)       const;
    vectII<T> operator/(const T& val)       const;
    vectII<T> operator+(const vectII<T>& a) const;
    vectII<T> operator-(const vectII<T>& a) const;
    vectII<T> operator*(const vectII<T>& a) const;// for sheaf
    bool operator==(const vectII<T>& a) const;
    bool operator!=(const vectII<T>& a) const;
};

typedef double vectR1;
typedef int    vectZ1;
typedef vectII<cmplex> vectC2;
typedef vectII<double> vectR2;
typedef vectII<int>    vectZ2;

vectR2 operator*(const double& val, const vectR2& a);
double Eprod(const vectR2& a, const vectR2& b);
double Iprod(const vectR2& a, const vectR2& b);

vectC2 operator*(const cmplex& val, const vectC2& a);
cmplex Hprod(const vectC2& a, const vectC2& b);

#endif
