#ifndef vectIII_included
#define vectIII_included

template<class T> class vectIII{
 public:
    T x, y, z;
    vectIII(const vectIII<T>& a);
    vectIII(const T& x, const T& y, const T& z);
    vectIII();
    ~vectIII() {}
    void print() const;
    void print(ofstream& fout) const;
    void setby(const T& x, const T& y, const T& z);
    void write(ofstream& fout) const;
    void read( ifstream& fin);
    void operator=(const vectIII<T>& a);
    void operator+=(const vectIII<T>& a);
    void operator-=(const vectIII<T>& a);
    vectIII<T> operator-() const;
    vectIII<T> operator+(const T& val)       const;
    vectIII<T> operator-(const T& val)       const;
    vectIII<T> operator*(const T& val)       const;
    vectIII<T> operator/(const T& val)       const;
    vectIII<T> operator+(const vectIII<T>& a) const;
    vectIII<T> operator-(const vectIII<T>& a) const;
    vectIII<T> operator*(const vectIII<T>& a) const;
    bool operator==(const vectIII<T>& a) const;
    bool operator<=(const vectIII<T>& a) const;
    bool operator>=(const vectIII<T>& a) const;
    bool operator<(const vectIII<T>& a)  const;
    bool operator>(const vectIII<T>& a)  const;
};

typedef double vectR1;
typedef int    vectZ1;
typedef vectIII<double> vectR3;
typedef vectIII<int>    vectZ3;

vectR3 operator*(const double& val, const vectR3& a);
vectR3 Eprod(const vectR3& a, const vectR3& b);
double Iprod(const vectR3& a, const vectR3& b);

#endif
